#include "demo_types.h"
#include "demo_config.h"

uint8_t faultCheck;
uint8_t touch;

void systemInit()
{
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_INT_PIN, _GPIO_INPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
    mikrobus_i2cInit( _MIKROBUS2, &_PROXFUSION_I2C_CFG[0] );
    mikrobus_logInit( _MIKROBUS2, 9600 );
    mikrobus_logWrite( "Initializing...", _LOG_LINE );
    Delay_ms( 100 );
}

void applicationInit()
{

    proxfusion_i2cDriverInit( (T_PROXFUSION_P)&_MIKROBUS2_GPIO, (T_PROXFUSION_P)&_MIKROBUS2_I2C, 0x44 );
    Delay_100ms();
    proxfusion_systemSetting(_PROXFUSION_SYSTEM_RESET |
                             _PROXFUSION_EVENT_MODE_1 |
                             _PROXFUSION_CLOCK_16MHz |
                             _PROXFUSION_ATI_ENABLED |
                             _PROXFUSION_ATI_BAND_1_16 |
                             _PROXFUSION_SYSTEM_ATI_RESET);
    Delay_100ms();
    proxfusion_EventMask( _PROXFUSION_MASK_SYS_EVENT );
    mikrobus_logWrite("ProxFusion is initialized",_LOG_LINE);
    c2x30wamp_gpioDriverInit( (T_C2X30WAMP_P)&_MIKROBUS1_GPIO );
    Delay_ms( 100 );

    c2x30wamp_enable( _C2X30WAMP_ENABLE );
    mikrobus_logWrite( "2x30W AMP is initialized", _LOG_LINE );
    Delay_ms( 200 );
}

void applicationTask()
{
    touch = proxfusion_Touch();
    if( touch == 1 )
    {
        c2x30wamp_mute( _C2X30WAMP_UNMUTE );
    }
    if( touch == 2 )
    {
        c2x30wamp_mute( _C2X30WAMP_MUTE );
    }
    
    Delay_ms( 100 );
}

void main()
{
    systemInit();
    applicationInit();

    while (1)
    {
        applicationTask();
    }
}